
-- aha=.rgfDirectory~new("java.lang.String")
aha=bsf.wrapStaticFields("java.lang.String")
say aha
say aha~Case_Insensitive_order
a=aha~Case_Insensitive_order
aha~Case_Insensitive_order=20060205
say aha~Case_Insensitive_order
aha~Case_Insensitive_order=a
say aha~Case_Insensitive_order
say

aha=bsf.wrapStaticFields("java.awt.font.OpenType")
say aha
say aha~tag_base
say aha~tag_base
say aha~tag_bloc
say aha~tag_bloc
-- say aha~"MaxUndMoritz"
-- say aha~at("MaxUndMoritz")

::requires bsf.cls



   /* Create and return an Object Rexx directory representing all static fields of the
    * given Java class or Java interface.
   */
::routine bsf.wrapStaticFields public
  parse arg JavaClassName
  return .JavaStaticFields.Directory~new(JavaClassName)

/*  This allows to wrap any Java class or interface as a directory of fields. This way
    Java field constants can be easily addressed/used via BSF. Any looked up Java constant
    field will be stored in the directory, speeding up future look-ups.
*/
::class  "JavaStaticFields.Directory"  subclass directory
::method JavaClassName   attribute class        -- memorize name of Java class
::method JavaClassObject attribute class        -- memorize Java class object
::method init
  parse arg JavaClassName

  if .local~hasentry(JavaClassName) then        -- if Java class exists already in the local environment, use it
     self~class~JavaClassObject=.local~entry(JavaClassName)
  else                                          -- load Java class and save the class object (string reference)
     self~class~JavaClassObject=bsf.loadClass(JavaClassName)

  self~class~JavaClassName=JavaClassName        -- save the Java class name

      -- define a method to be run, if an access to an unknown entry occurs;
      -- the method's code is located in the private method "do_the_work" of this class
  self~setmethod("UNKNOWN",  self~class~method("DO_THE_WORK"))



  -- this method will be used to deal with UNKNOWN messages; it will retrieve the unknown message name
  -- as a fieldName into the Java class object stored with this class
::method do_the_work private
  parse arg fieldName

      -- look up the Java class for the appropriate field value;
  val=bsf("getStaticValue", self~class~JavaClassObject, fieldName)
  self~setentry(fieldName, val)  -- save the value in the directory
  return val                     -- return the looked up value

